var map;
var m_counter = 0;
var map_latlng;
var map_width;
var polyline = null;
var path = [];

function dom_initialize() {
	//
}

function map_initialize() {
	
	//デフォルトの位置
	map_latlng = new google.maps.LatLng(35.36286726458948,138.73157501220703);
	var map_Options = {
		zoom: 12,
		center: map_latlng,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		navigationControl:true,
		draggable:true
	};
	map = new google.maps.Map(document.getElementById("map_canvas"), map_Options);
	var pageHeight = $(document).height();
	$("#map_canvas").css("height",pageHeight);
	
	
	google.maps.event.addListener(map, 'tilesloaded', function(event) {
    	//
    	
		if (m_counter == 0) {
			hide_map();
		}
		
	});
	
	marker = new google.maps.Marker({
		map: map,
		icon:"img/phone.png",
		raiseOnDrag:true,//bouncy
		position: map_latlng,
		animation: google.maps.Animation.DROP,
		clickable:true,
		draggable:false
	});
}

function HomeControl(controlDiv, map) {
	var controlUI = document.createElement('DIV');
	controlUI.style.backgroundColor = 'white';
	
	controlUI.title = 'direction';
	controlDiv.appendChild(controlUI);
	
	var controlText = document.createElement('DIV');
	controlUI.id = 'test_button';
	controlText.style.top = '80px';
	controlText.style.left = '100px';
	controlText.innerHTML = '<input type="button" value="戻る" onClick="hide_map()">';
	
	controlUI.appendChild(controlText);
	
	
}


function get_mapinfo(lat,lng,width,height,counter){
	m_counter = counter;
	map_width = width;
	document.getElementById("map_canvas").style.width = width*1 + "px";
	document.getElementById("map_canvas").style.height = height*0.6 + "px";
	
	if (lat == 0){
		lat = 35.36286726458948;
	}
	if (lng == 0){
		lng = 138.73157501220703;
	}
	
	map_latlng = new google.maps.LatLng(lat,lng);
	map.setCenter(map_latlng);
	if (m_counter != 0) {
		document.getElementById("map_canvas").style.visibility = "visible";
		document.getElementById("map_operation").style.visibility = "visible";
		document.getElementById("map_append").style.visibility = "hidden";
	}
	marker.setPosition(map_latlng);
}

function move_map(lat,lng){
	map_latlng = new google.maps.LatLng(lat,lng);
	map.setCenter(map_latlng);
	marker.setPosition(map_latlng);
}


function get_speechinfo(speechresult){
	
	
	var temp_list = speechresult.split("/");
	var html_content = "";
	
	html_content += '<input type="text" id="selected_item" value=""><br>';
	
	if (temp_list.length != 0) {
		
		if (temp_list.length > 4) {
			var max = 4;
		}else{
			var max = temp_list.length;
		}
		
		for (var i = 0;i < max;i++) {
			
			if (temp_list[i] != "") {
				html_content += '<table><tr>';
				html_content += '<th><input type="radio" name="sel_speech" id="sel_speech' + i + '" value="' + i + '"></th><th><font size=5 id="item_font' + i + '" onClick="sel_item(' + i + ')">' + temp_list[i] + '</font></th>';
				html_content += '</tr></table><br>';
			}
		}
		
		document.getElementById("map_canvas").style.visibility = "hidden";
		document.getElementById("map_operation").style.visibility = "visible";
		document.getElementById("map_append").style.visibility = "visible";
		
		document.getElementById("map_append").innerHTML = html_content;
		
		open_softkeyboard();
	}
	
	//
}

function open_softkeyboard(){
	android_ar.open_softkeyboard();
}

function sel_item(index){
	var id = "sel_speech" + index;
	document.getElementById(id).checked = true;
	
	var id2 = "item_font" + index;
	var item_name = document.getElementById(id2).innerHTML;
	document.getElementById("selected_item").value = item_name;
}

function get_val(val){
	easy_direction(val);
	document.getElementById("mon").value = val;
}

function easy_direction(angle){
	var pix_num = 200;//スクリーン上のピクセル数
	
	angle += 90;
	
	var map_bounds = map.getBounds();
	var swLatlng = map_bounds.getSouthWest();
	var neLatlng = map_bounds.getNorthEast();
	
	var sw_lng = swLatlng.lng();
	var ne_lng = neLatlng.lng();
	
	var dif = Math.abs(sw_lng - ne_lng);
	
	var degparpix = Math.abs(dif / map_width);
	
	var deg = pix_num * degparpix;
	
	if (((angle >= 0)&&(angle <= 90))||((angle > 360)&&(angle <= 450))){
		var rad = angle * Math.PI / 180;
		var new_lng = deg * Math.sin(rad) + map.getCenter().lng();
		var new_lat = deg * Math.cos(rad) + map.getCenter().lat();
		
	}else if ((angle > 90)&&(angle <= 180)){
		angle = 180 - angle;
		var rad = angle * Math.PI / 180;
		var new_lng = deg * Math.sin(rad) + map.getCenter().lng();
		var new_lat = map.getCenter().lat() - deg * Math.cos(rad);
		
		
	}else if ((angle > 180)&&(angle <= 270)){
		angle = angle - 180;
		var rad = angle * Math.PI / 180;
		var new_lng = map.getCenter().lng() - deg * Math.sin(rad);
		var new_lat = map.getCenter().lat() - deg * Math.cos(rad);
		
		
	}else if ((angle > 270)&&(angle <= 360)){
		angle = 360 - angle;
		var rad = angle * Math.PI / 180;
		var new_lng = map.getCenter().lng() - deg * Math.sin(rad);
		var new_lat = deg * Math.cos(rad) + map.getCenter().lat();
	}
	

	if (polyline != null){
		polyline.setMap(null);
		path = []
	}
	
	path.push(map.getCenter());
	path.push(new google.maps.LatLng(new_lat,new_lng));
	var c="#00f";
	var sw=5;
	var so=1.0;
	polyline = new google.maps.Polyline({map: map, path: path,strokeColor: c, strokeOpacity:so, strokeWeight:sw});
	
	polyline.setMap(map);
}

function move_cat(){
	//dummy
	//marker_x,marker_y,cat_x,cat_y
	android_ar.seImageOnscreen(-1,-1,200,300);
}

function get_myid(id){
	alert(id);
}
