package com.wisteria.arguide2;


import android.app.Activity;
import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
//GPS
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.location.LocationProvider;
//compass sensor
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
//TextToSpeech
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;
//SpeechRecognizer
import android.speech.RecognizerIntent;
import java.util.ArrayList;

import android.os.Bundle;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.WindowManager.LayoutParams;
import android.webkit.WebChromeClient; 
import android.webkit.WebView;
import android.content.Context;

import android.os.Handler;
import android.widget.TextView;
import android.widget.EditText;
import android.widget.TextView.BufferType;


//import android.widget.Button;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.view.View.OnClickListener; 

import android.view.Display;

import android.app.AlertDialog;
import com.phonegap.*;
//ID
import android.provider.Settings;



public class AR_GuideIIActivity extends DroidGap implements OnInitListener, LocationListener {
    /** Called when the activity is first created. */
	private WebView webView = null;
	private float marker_x = -1;
	private float marker_y = -1;
	private float cat_x = -1;
	private float cat_y = -1;
	
	private int screen_width = -1;
	private int screen_height = -1;
	
	private int m_counter = 0;
	
	private Bitmap bitmap_A;
	private Bitmap bitmap_B;
	//
	private AlertDialog.Builder dlg;
	//TextToSpeech
	private TextToSpeech tts;
	//
	private EditText textedit;
	private TextView tv1;
	private TextView tv2;
	private Handler mHandler;       
	private String result_content;
	
	//
	private String c_lat;
	private String c_lng;
	private String north_direction;
	private double prev_direction;
	private int prev_dir = -1;
	private double direction;
	private String pitch_rotation;
	private String roll_ratation;
	//softKeyBoard
	private boolean skb_flag = false;
	//compass sensor
	private SensorManager mSensorManager;
	private Sensor mSensor;
	private final SensorEventListener mListener = new SensorEventListener() {
		public void onSensorChanged(SensorEvent event) {
			if (event.sensor.getType() == Sensor.TYPE_ORIENTATION) {
				String sensor_changed = event.values[0] + "\n" + event.values[1] + "\n" + event.values[2];
				
				tv2.setText(sensor_changed,BufferType.NORMAL);
				
				direction = event.values[0] * 0.1 + prev_direction * 0.9;
				
				north_direction = direction + "";
				pitch_rotation = event.values[1] + "";
				roll_ratation = event.values[2] + "";
				
				prev_direction = event.values[0];
				
				//指定時の直前・直後の２０個くらいの値の中央値を見る
				
				//あるいは、5度ごとに変化を見る(描画頻度の軽減)
				int dir = (int)event.values[0];
				
				/* Lite ***********************
				****************** */
				
				int dir1 = dir/10;
				dir1 = dir1 * 10;
				int dif = dir - dir1;
				
				
				if ((dif >= 0)&&(dif <= 3)) {
					dir1 = dir1 + 0;
				}else if ((dif > 3)&&(dif <= 7)) {
					dir1 = dir1 + 5;
				}else{
					dir1 = dir1 + 10;
				}
				
				
				if (prev_dir != -1) {
					
					//softKeyBoard
					if ((dir1 != prev_dir)&&(skb_flag == false)) {
						webView.loadUrl("javascript:get_val(" + dir1 + ")");
					}
					
					
				}
				
				prev_dir = dir1;
				//
			}
			
		}
		public void onAccuracyChanged(Sensor sensor, int accuracy) {
			//
		}
	};
	
	//GPS
	private LocationManager mLocationManager;
	//
	private static final int REQUEST_CODE = 0;
	//
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //
        dlg = new AlertDialog.Builder(this);
        //sensor
        mSensorManager = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
        mSensor = mSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION);
        //GPS
        mLocationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        //
        mHandler = new Handler();        
        //
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(new CameraPreview(this));
		//
		addContentView(new OverlayView(this), new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
		//
	    WindowManager wm = (WindowManager)getSystemService(WINDOW_SERVICE);
	    Display disp = wm.getDefaultDisplay();
	    
	    screen_width = disp.getWidth();
	    screen_height = disp.getHeight();
	    
	    marker_x = disp.getWidth() / 2 - 50;
	    marker_y = disp.getHeight() / 2 - 50;
		
        //
		
		LinearLayout linear_LayoutL = new LinearLayout(this);
		linear_LayoutL.setOrientation(LinearLayout.VERTICAL);
		linear_LayoutL.setGravity(Gravity.LEFT|Gravity.CENTER);
        addContentView(linear_LayoutL, new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
        
        LinearLayout linear_LayoutR = new LinearLayout(this);
        linear_LayoutR.setOrientation(LinearLayout.VERTICAL);
        linear_LayoutR.setGravity(Gravity.RIGHT|Gravity.CENTER);
        addContentView(linear_LayoutR, new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
        
        LinearLayout linear_LayoutC = new LinearLayout(this);
        linear_LayoutC.setOrientation(LinearLayout.VERTICAL);
        linear_LayoutC.setGravity(Gravity.CENTER);
        addContentView(linear_LayoutC, new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.FILL_PARENT));
        
        
        
        ImageButton imgbtn_A  = new ImageButton(this);
        imgbtn_A.setImageResource(R.drawable.mapicon);
        imgbtn_A.setOnClickListener(new OnClickListener(){
        	@Override
        	public void onClick(View v) {
        		imagButtonA_OnClick();
        	}
        });   
		linear_LayoutR.addView(imgbtn_A, new LinearLayout.LayoutParams(100,100));
		
		ImageButton imgbtn_B  = new ImageButton(this);
		imgbtn_B.setImageResource(R.drawable.speaker);
		imgbtn_B.setOnClickListener(new OnClickListener(){
        	@Override
        	public void onClick(View v) {
        		imagButtonB_OnClick();
        	}
        });   
		linear_LayoutR.addView(imgbtn_B, new LinearLayout.LayoutParams(100,100));
		
		ImageButton imgbtn_C  = new ImageButton(this);
		imgbtn_C.setImageResource(R.drawable.gmaps);
		imgbtn_C.setOnClickListener(new OnClickListener(){
        	@Override
        	public void onClick(View v) {
        		imagButtonC_OnClick();
        	}
        });   
		linear_LayoutR.addView(imgbtn_C, new LinearLayout.LayoutParams(100,100));
		
		ImageButton imgbtn_D  = new ImageButton(this);
		imgbtn_D.setImageResource(R.drawable.sr);
		imgbtn_D.setOnClickListener(new OnClickListener(){
        	@Override
        	public void onClick(View v) {
        		imagButtonD_OnClick();
        	}
        });   
		linear_LayoutR.addView(imgbtn_D, new LinearLayout.LayoutParams(100,100));
		
		
		
		textedit = new EditText(this);
        textedit.setText("info",BufferType.NORMAL);
        textedit.setHeight(50);
        textedit.setEnabled(false);
        textedit.setFocusableInTouchMode(true);
        linear_LayoutL.addView(textedit, new LinearLayout.LayoutParams(170,250));
		
        
        tv1 = new TextView(this);
        tv1.setText("GPS information");
        linear_LayoutL.addView(tv1, new LinearLayout.LayoutParams(170,70));

        tv2 = new TextView(this);
        tv2.setText("Compass information");
        linear_LayoutL.addView(tv2, new LinearLayout.LayoutParams(170,80));
		//
		webView = new WebView(this);
		webView.setWebChromeClient(new WebChromeClient());
		webView.getSettings().setJavaScriptEnabled(true);
		JavascriptAdapter jsobj = new JavascriptAdapter(this);
	    webView.addJavascriptInterface(jsobj, "android_ar");
	    webView.loadUrl("file:///android_asset/www/index.html");
	    webView.setVisibility(View.GONE);
	    linear_LayoutC.addView(webView, new LinearLayout.LayoutParams(disp.getWidth()* 1,disp.getHeight()* 1));
	    
	    //TextToSpeech
	    tts = new TextToSpeech(getApplicationContext(), this);
	    
	    
	    //
	    show_map();
    }
    
    private void imagButtonA_OnClick(){

    	webView.loadUrl("javascript:loc_judgement()");
	    
    }
    
    private void imagButtonB_OnClick(){

    	webView.loadUrl("javascript:speak_it()");
	    
    }
    
    private void imagButtonC_OnClick(){
    	show_map();
    }
    
    private void show_map(){
    	m_counter++;
    	
    	if (c_lat == null) {
			c_lat = "0";
		}
		if (c_lng == null) {
			c_lng = "0";
		}
		
		
		String arg = c_lat + "," + c_lng + "," + screen_width + "," + screen_height + "," + m_counter;
    	webView.loadUrl("javascript:get_mapinfo(" + arg + ")");
    	
    	webView.setVisibility(View.VISIBLE);
    }
    
    private void imagButtonD_OnClick(){
    	//SpeechRecognizer
    	try {
    		Intent intent = new Intent(
    		RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
    		intent.putExtra(
    		RecognizerIntent.EXTRA_LANGUAGE_MODEL,
    		RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
    		intent.putExtra(
    		RecognizerIntent.EXTRA_PROMPT,
    		"SpeechRecognizer");
    		//
    		startActivityForResult(intent, REQUEST_CODE);
    	} catch (ActivityNotFoundException e) {
    		String resultsString = "ActivityNotFoundException";
    		webView.loadUrl("javascript:get_speechinfo('" + resultsString + "')");
    	}
    	
    	
    }
    
    //SpeechRecognizer
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
    	
    	if (requestCode == REQUEST_CODE && resultCode == RESULT_OK) {
    		
    		String results = "";
    		
    		ArrayList<String> strings = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
    		
    		if (strings.size() == 0) {
    			results = "No Data";
    		}else{
	    		for (int i = 0; i< strings.size(); i++) {
	    			results += strings.get(i) + "/";
	    		}
	    		
	    		show_map();
    		}
    		
    		webView.loadUrl("javascript:get_speechinfo('" + results + "')");
    		
    	}
    	super.onActivityResult(requestCode, resultCode, data);
    }
    
    //JavaScript -> Java
    class JavascriptAdapter {
    	
    	private Context con;
    	
    	public JavascriptAdapter(Context con) {
            this.con = con;
         }
    	//
    	public void start_tts(String speec_content){
    		tts.speak(speec_content, TextToSpeech.QUEUE_FLUSH, null);
    	}
    	//
    	public void seImageOnscreen(float mx,float my,float cx,float cy) {
    		OverlayView ol = new OverlayView(con);
    		ol.set_imagePos(mx,my,cx,cy);
    		
    	}
    	
    	public void open_softkeyboard(){
    		//softKeyBoard
    		skb_flag = true;
    		//
    		(new Thread(new Runnable() {
        		@Override
        		public void run() {
        			mHandler.post(new Runnable() {
        				@Override
        				public void run() {
        					webView.requestFocus(View.FOCUS_DOWN);
        				}
        			});
        		}
        	})).start();
    		
    	}
    	public void hide_map() {
    		//softKeyBoard
    		if (skb_flag == true) {
    			skb_flag = false;
    		}
    		
    		(new Thread(new Runnable() {
        		@Override
        		public void run() {
        			mHandler.post(new Runnable() {
        				@Override
        				public void run() {
        					webView.setVisibility(View.GONE);
        				}
        			});
        		}
        	})).start();
    	}
    	
    	public String ret_information() {
    		if (c_lat == null) {
    			c_lat = "";
    		}
    		if (c_lng == null) {
    			c_lng = "";
    		}
    		
    		String ret = c_lat + "/" + c_lng + "/" + north_direction + "/" + pitch_rotation + "/" + roll_ratation;
    		return ret;
    		
    	}
    	
    	public void set_result(String result) {
    		result_content = result;
    		(new Thread(new Runnable() {
        		@Override
        		public void run() {
        			mHandler.post(new Runnable() {
        				@Override
        				public void run() {
        					textedit.setText(result_content,BufferType.NORMAL);
        				}
        			});
        		}
        	})).start();
    	}
    }
    
    class OverlayView extends View {

		public OverlayView(Context context) {
			super(context);
			bitmap_A = BitmapFactory.decodeResource(context.getResources(), R.drawable.androidmarker);
			bitmap_B = BitmapFactory.decodeResource(context.getResources(), R.drawable.maneki);
			
			setFocusable(true);
		}
		
		@Override
		protected void onDraw(Canvas canvas) {
			super.onDraw(canvas);
			canvas.drawColor(Color.TRANSPARENT);
			
			if (marker_x >= 0) {
				canvas.drawBitmap(bitmap_A, marker_x, marker_y, null);
			}
			
			if (cat_x >= 0) {
				canvas.drawBitmap(bitmap_B, cat_x, cat_y, null);
			}
			
			
			
		}
		
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			
			marker_x = event.getX() - 50;
			marker_y = event.getY() - 50;
			
			
			invalidate();
			
			return true;
		}
		
		public void set_imagePos(float mx,float my,float cx,float cy){
			if ((mx != -1)&&(my != -1)){
				marker_x = mx;
				marker_y = my;
			}
			
			if ((cx != -1)&&(cy != -1)){
				cat_x = cx;
				cat_y = cy;
			}
			
			invalidate();
		}
		
		
    }
    
    
    @Override
    protected void onResume(){
    	//GPS
    	
    	if (mLocationManager != null) {
    	    mLocationManager.requestLocationUpdates(
    	        LocationManager.GPS_PROVIDER,
    	        0,
    	        0,
    	        this);
    	}
    	
    	super.onResume();
    	//compass sensor
    	mSensorManager.registerListener(mListener, mSensor,
    		SensorManager.SENSOR_DELAY_GAME);
    }

    @Override
    protected void onStop(){
    	//GPS
    	mSensorManager.unregisterListener(mListener);
    	super.onStop();
    }
    
    @Override
    protected void onPause() {
    	//GPS
    	if (mLocationManager != null) {
    		mLocationManager.removeUpdates(this);
    	}
    	super.onPause();
    }
    
    @Override
    public void onLocationChanged(Location location) {
    	c_lat = String.valueOf(location.getLatitude());
    	c_lng = String.valueOf(location.getLongitude());
    	
    	String sensor_changed = String.valueOf(location.getLatitude()) + ", " + String.valueOf(location.getLongitude());
		tv1.setText(sensor_changed,BufferType.NORMAL);
		
		String arg = c_lat + "," + c_lng;
    	webView.loadUrl("javascript:move_map(" + arg + ")");
    	//GPS
    
    }
    
    @Override
    public void onProviderDisabled(String provider) {
    	//GPS
    }
    
    @Override
    public void onProviderEnabled(String provider) {
    	//GPS
    }
    
    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {
    	//GPS
    	switch (status) {
    		case LocationProvider.AVAILABLE:
    			//
    			break;
    		case LocationProvider.OUT_OF_SERVICE:
    			//
    			break;
    		case LocationProvider.TEMPORARILY_UNAVAILABLE:
    			//
    			break;
    	}
    }
    
    @Override
    public void onInit(int status) {
    	//TextToSpeech
        if (status == TextToSpeech.SUCCESS) {
            //
        } else {
            //
            
        }
    }

}